//Problema 5_9

clear;
clc;
clf;
//--------------------------------------------------------
// Parametros del sistema
Kt=0.68;
Kw=0.678;
N=0.1;
J=0.05;
B=0.02;
La=0.02;
Ra=2;

Ts=0.01; // Frecuencia de muestreao
//--------------------------------------------------------
// Calculo transferencia de la planta discreta
s=%s;
numGP=Kt*N;
denGP=(s)*(s^2*J*La+s*(J*Ra+B*La)+Kt*Kw);
GP=syslin('c',numGP/denGP);

[Ds,numGPD,denGPD]=ss2tf(dscr(GP,Ts));
GPD=syslin('d',numGPD/denGPD+Ds);
zpk(GPD)

//--------------------------------------------------------
// Determinación del cero fuera del circulo unitario

Z0=-roots(numGPD)(1);

//--------------------------------------------------------
// Se propone la siguiente solución

// T(z)=(a1 z^-1 + a2 z^-2 + a3 z^-3)(1+ Z0 z^-1)
// [1-T(z)]=(1- z^-1)^2 [1+ b1 z^-1 +b2 z^-2]
//--------------------------------------------------------

// Resolucion sistema de ecuaciones 

// a1 + b1 = 2
// Z0 a1 + a2 - 2 b1 = -2
// Z0 a2 + a3 + b1 = 2
// Z0 a3 = -1

//--------------------------------------------------------
// Calculo de coeficientes
// Existe un grado de libertad
// Asumimos un valor para b2

b2=1;
//b2=2;  // Para probar otra alternativa
M=[1,0,0,1;Z0,1,0,-2;0,Z0,1,1;0,0,Z0,0]; // Matriz del sistema
Sol=inv(M)*[2;-b2-1;2*b2;-b2];

a1=Sol(1)
a2=Sol(2)
a3=Sol(3)
b1=Sol(4)

//----------------------------------------------------------
// Calculo del compensador
z=%z;
numDZ=(a1*z^2+a2*z+a3)*(z+Z0)*denGPD;
denDZ=((z-1)^2)*(z^2+b1*z+b2)*numGPD;
DZ=syslin('d',numDZ/denDZ);
zpk(DZ)

// ----------------------------------------------------------
// Analizo respuesta a lazo cerrado
TLC=DZ*GPD/(1+DZ*GPD);

//-------Salida --------
u=0:Ts:0.2;
t=0:Ts:0.2;
y=flts(u,TLC);
plot2d2(t',y')
hold on
plot(t',y');
plot(t',u','--r')
hold off;

//-------Error --------
clf
er=u-y;
plot2d2(t',er')

//-------Control --------
clf
u=0:Ts:0.2;
t=0:Ts:0.2;
TLControl=DZ/(1+DZ*GPD);
ucontrol=flts(u,TLControl);
plot2d2(t',ucontrol')

//----------------------------------------------------------
// Analisis de Lugar de Raices de GH
clf
GH=DZ*GPD;
zpk(GH)
evans(GH,150)


//-----------------------------------------------------------------------
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//-----------------------------------------------------------------------

// Redondeo de coeficientes

numDZ2=39732*(z+1.36)*(z-0.95)*(z-0.7)*(z-0.4);
denDZ2=(z-1)*(z+0.2)*(z^2+1.644*z+1);
DZ2=syslin('d',numDZ2/denDZ2);
zpk(DZ2)

//---------------------------------------------------------------------


clf;
TLC2=DZ2*GPD/(1+DZ2*GPD);
u=0:Ts:0.2;
t=0:Ts:0.2;
y2=flts(u,TLC2);
plot2d2(t',y2')
hold on
plot(t',y2');
plot(t',u','--r')

clf;
er2=u-y2;
plot2d2(t',er2')


